# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.gcp_marketplace_offer_deal_type import GcpMarketplaceOfferDealType
from typing import Optional, Set
from typing_extensions import Self

class GcpMarketplacePrivateOfferPolicies(BaseModel):
    """
    GcpMarketplacePrivateOfferPolicies
    """ # noqa: E501
    cancellation_policy: Optional[StrictStr] = Field(default=None, description="The cancellation policy of the offer.", alias="cancellationPolicy")
    default_renewal_policy: Optional[StrictStr] = Field(default=None, description="The default renewal policy of the offer.", alias="defaultRenewalPolicy")
    downgrade_policy: Optional[StrictStr] = Field(default=None, description="The downgrade policy of the offer.", alias="downgradePolicy")
    max_renewal_times: Optional[StrictStr] = Field(default=None, description="The max renewal times of the offer.", alias="maxRenewalTimes")
    offer_deal_type: Optional[GcpMarketplaceOfferDealType] = Field(default=None, description="The offer deal type of the offer.", alias="offerDealType")
    purchase_approval: Optional[StrictStr] = Field(default=None, description="The purchase approval of the offer.", alias="purchaseApproval")
    purchase_approval_override: Optional[StrictStr] = Field(default=None, description="The purchase approval override of the offer.", alias="purchaseApprovalOverride")
    __properties: ClassVar[List[str]] = ["cancellationPolicy", "defaultRenewalPolicy", "downgradePolicy", "maxRenewalTimes", "offerDealType", "purchaseApproval", "purchaseApprovalOverride"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GcpMarketplacePrivateOfferPolicies from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GcpMarketplacePrivateOfferPolicies from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cancellationPolicy": obj.get("cancellationPolicy"),
            "defaultRenewalPolicy": obj.get("defaultRenewalPolicy"),
            "downgradePolicy": obj.get("downgradePolicy"),
            "maxRenewalTimes": obj.get("maxRenewalTimes"),
            "offerDealType": obj.get("offerDealType"),
            "purchaseApproval": obj.get("purchaseApproval"),
            "purchaseApprovalOverride": obj.get("purchaseApprovalOverride")
        })
        return _obj


