# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.gcp_marketplace_revenue_share_type import GcpMarketplaceRevenueShareType
from suger_sdk_python.models.gcp_marketplace_revenue_share_value import GcpMarketplaceRevenueShareValue
from typing import Optional, Set
from typing_extensions import Self

class GcpMarketplaceRevenueShareChange(BaseModel):
    """
    GcpMarketplaceRevenueShareChange
    """ # noqa: E501
    revenue_share: Optional[GcpMarketplaceRevenueShareValue] = Field(default=None, alias="revenueShare")
    revenue_share_type: Optional[GcpMarketplaceRevenueShareType] = Field(default=None, alias="revenueShareType")
    start_time: Optional[StrictStr] = Field(default=None, alias="startTime")
    __properties: ClassVar[List[str]] = ["revenueShare", "revenueShareType", "startTime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GcpMarketplaceRevenueShareChange from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of revenue_share
        if self.revenue_share:
            _dict['revenueShare'] = self.revenue_share.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GcpMarketplaceRevenueShareChange from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "revenueShare": GcpMarketplaceRevenueShareValue.from_dict(obj["revenueShare"]) if obj.get("revenueShare") is not None else None,
            "revenueShareType": obj.get("revenueShareType"),
            "startTime": obj.get("startTime")
        })
        return _obj


