# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.snowflake_marketplace_plan_installment_schedule import SnowflakeMarketplacePlanInstallmentSchedule
from typing import Optional, Set
from typing_extensions import Self

class SnowflakeMarketplaceOfferPaymentTerms(BaseModel):
    """
    SnowflakeMarketplaceOfferPaymentTerms
    """ # noqa: E501
    installment_schedule: Optional[SnowflakeMarketplacePlanInstallmentSchedule] = Field(default=None, description="The installment schedule for the offer.")
    payment_type: Optional[StrictStr] = Field(default=None, description="The pricing plan payment types. Accepted values are INVOICE, CREDIT_CARD, INSTALLMENT.")
    __properties: ClassVar[List[str]] = ["installment_schedule", "payment_type"]

    @field_validator('payment_type')
    def payment_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['INVOICE', 'CREDIT_CARD', 'INSTALLMENT']):
            raise ValueError("must be one of enum values ('INVOICE', 'CREDIT_CARD', 'INSTALLMENT')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SnowflakeMarketplaceOfferPaymentTerms from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of installment_schedule
        if self.installment_schedule:
            _dict['installment_schedule'] = self.installment_schedule.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SnowflakeMarketplaceOfferPaymentTerms from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "installment_schedule": SnowflakeMarketplacePlanInstallmentSchedule.from_dict(obj["installment_schedule"]) if obj.get("installment_schedule") is not None else None,
            "payment_type": obj.get("payment_type")
        })
        return _obj


