# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SnowflakeMarketplaceProductMetadata(BaseModel):
    """
    SnowflakeMarketplaceProductMetadata
    """ # noqa: E501
    are_terms_provided_offline: Optional[StrictBool] = Field(default=None, alias="areTermsProvidedOffline")
    business_needs: Optional[Dict[str, Any]] = Field(default=None, alias="businessNeeds")
    description: Optional[StrictStr] = None
    has_free_sample_data: Optional[StrictBool] = Field(default=None, alias="hasFreeSampleData")
    is_with_standard_terms: Optional[StrictBool] = Field(default=None, alias="isWithStandardTerms")
    paid_attributes: Optional[Dict[str, Any]] = Field(default=None, alias="paidAttributes")
    share: Optional[StrictStr] = None
    title: Optional[StrictStr] = None
    usage: Optional[Dict[str, Any]] = None
    __properties: ClassVar[List[str]] = ["areTermsProvidedOffline", "businessNeeds", "description", "hasFreeSampleData", "isWithStandardTerms", "paidAttributes", "share", "title", "usage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SnowflakeMarketplaceProductMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SnowflakeMarketplaceProductMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "areTermsProvidedOffline": obj.get("areTermsProvidedOffline"),
            "businessNeeds": obj.get("businessNeeds"),
            "description": obj.get("description"),
            "hasFreeSampleData": obj.get("hasFreeSampleData"),
            "isWithStandardTerms": obj.get("isWithStandardTerms"),
            "paidAttributes": obj.get("paidAttributes"),
            "share": obj.get("share"),
            "title": obj.get("title"),
            "usage": obj.get("usage")
        })
        return _obj


